import {APP_INITIALIZER, NgModule} from '@angular/core';
import {BrowserModule} from '@angular/platform-browser';
import {AppRoutingModule} from './app-routing.module';
import {AppComponent} from './app.component';
import {BrowserAnimationsModule} from '@angular/platform-browser/animations';
import {HttpClientModule} from '@angular/common/http';
import {FamilyComponent} from './components/family/family.component';
import {ResultComponent} from './components/result/result.component';
import {DataService} from './services/data.service';
import {MatToolbarModule} from '@angular/material/toolbar';
import {MatIconModule} from '@angular/material/icon';
import {DialogComponent} from './components/dialog/dialog.component';
import {MatSortModule} from '@angular/material/sort';
import {FamiliesTreeComponent} from './components/families-tree/families-tree.component';
import {ReactiveFormsModule} from "@angular/forms";
import {MatDialogModule} from "@angular/material/dialog";
import {MatCardModule} from "@angular/material/card";
import {MatSnackBarModule} from "@angular/material/snack-bar";
import {MatTableModule} from "@angular/material/table";
import {MatButtonModule} from "@angular/material/button";
import {MatSlideToggleModule} from "@angular/material/slide-toggle";
import {MatFormFieldModule} from "@angular/material/form-field";
import {MatPaginatorModule} from "@angular/material/paginator";
import {MatAutocompleteModule} from "@angular/material/autocomplete";
import {MatInputModule} from "@angular/material/input";
import {MatSelectModule} from "@angular/material/select";
import {MatListModule} from "@angular/material/list";
import { MinPipe } from './pipes/min.pipe';
import { MaxPipe } from './pipes/max.pipe';
import {MatTooltipModule} from "@angular/material/tooltip";


@NgModule({
  declarations: [
    AppComponent,
    DialogComponent,
    FamiliesTreeComponent,
    FamilyComponent,
    ResultComponent,
    MinPipe,
    MaxPipe
  ],
  imports: [
    BrowserModule,
    AppRoutingModule,
    BrowserAnimationsModule,
    HttpClientModule,
    MatDialogModule,
    MatCardModule,
    MatToolbarModule,
    MatSnackBarModule,
    MatTableModule,
    MatButtonModule,
    MatIconModule,
    MatSlideToggleModule,
    MatFormFieldModule,
    MatPaginatorModule,
    MatSortModule,
    MatAutocompleteModule,
    ReactiveFormsModule,
    MatInputModule,
    MatSelectModule,
    MatListModule,
    MatTooltipModule
  ],
  providers: [{
    provide: APP_INITIALIZER,
    useFactory: getAllResults,
    deps: [DataService],
    multi: true
  }],
  bootstrap: [AppComponent]
})
export class AppModule {
}

export function getAllResults(provider: DataService) {
  return () => provider.loadAnalysisResults();
}


